ak47projectileHandler = {
	shellNum = 1,
	shells = {},
	defaultShell = {active = false}
}

casing = {
	amount = 1,
	shells = {},
	defaultShell = {
		active = false,
		grenadeTimer = 0,
		boomTimer = 0,
		bounces = 0,
		pos = Vec(0,0,0),
		type = "casing",
		crot = 0
	}
}

function init()
	shootTimer = 0
	shotDelay = 0.09
	damage = 0.15
	gravity = Vec(0, -40, 0)
	velocity = 3
	maxMomentum = 4

	for i=1, 150 do
		ak47projectileHandler.shells[i] = deepcopy(ak47projectileHandler.defaultShell)
	end

	valkval = 0.4
	startvalkval = valkval
	Head = FindBody("Head")
	HeadBloodCapacity = GetBodyMass(Head)
	HeadBloodLevel = HeadBloodCapacity * 20
	StartingBleed = HeadBloodCapacity
	MaxBloodCapacity = GetBodyMass(Head)
	bleed = true

	Torso = FindBody("Torso")
	TorsoBloodCapacity = GetBodyMass(Torso)
	TorsoBloodLevel = TorsoBloodCapacity * 20
	StartingBleed1 = TorsoBloodCapacity
	MaxBloodCapacity1 = GetBodyMass(Torso)
	bleed1 = true

	LARM = FindBody("LARM")
	LARMBloodCapacity = GetBodyMass(LARM)
	LARMBloodLevel = LARMBloodCapacity * 20
	StartingBleed2 = LARMBloodCapacity
	MaxBloodCapacity2 = GetBodyMass(LARM)

	bleed2 = true

	LLARM = FindBody("LLARM")
	LLARMBloodCapacity = GetBodyMass(LLARM)
	LLARMBloodLevel = LLARMBloodCapacity * 20
	StartingBleed3 = LLARMBloodCapacity
	MaxBloodCapacity3 = GetBodyMass(LLARM)
	bleed3 = true

	RARM = FindBody("RARM")
	RARMBloodCapacity = GetBodyMass(RARM)
	RARMBloodLevel = RARMBloodCapacity * 20
	StartingBleed4 = RARMBloodCapacity
	MaxBloodCapacity4 = GetBodyMass(RARM)
	bleed4 = true

	RRARM = FindBody("RRARM")
	RRARMBloodCapacity = GetBodyMass(RRARM)
	RRARMBloodLevel = RRARMBloodCapacity * 20
	StartingBleed5 = RRARMBloodCapacity
	MaxBloodCapacity5 = GetBodyMass(RRARM)
	bleed5 = true

	LLEG = FindBody("LLEG")
	LLEGBloodCapacity = GetBodyMass(LLEG)
	LLEGBloodLevel = LLEGBloodCapacity * 20
	StartingBleed6 = LLEGBloodCapacity
	MaxBloodCapacity6 = GetBodyMass(LLEG)
	bleed6 = true

	LLLEG = FindBody("LLLEG")
	LLLEGBloodCapacity = GetBodyMass(LLLEG)
	LLLEGBloodLevel = LLLEGBloodCapacity * 20
	StartingBleed7 = LLLEGBloodCapacity
	MaxBloodCapacity7 = GetBodyMass(LLLEG)
	bleed7 = true

	RLEG = FindBody("RLEG")
	RLEGBloodCapacity = GetBodyMass(RLEG)
	RLEGBloodLevel = RLEGBloodCapacity * 20
	StartingBleed8 = RLEGBloodCapacity
	MaxBloodCapacity8 = GetBodyMass(RLEG)
	bleed8 = true

	RRLEG = FindBody("RRLEG")
	RRLEGBloodCapacity = GetBodyMass(RRLEG)
	RRLEGBloodLevel = RRLEGBloodCapacity * 20
	StartingBleed9 = RRLEGBloodCapacity
	MaxBloodCapacity9 = GetBodyMass(RRLEG)
	bleed9 = true

	antibleed = 15 -- only affects smoke speed
	extremeantibleed = 500 -- affects extreme bleed which is caused by total organ failure, reduce for blood to explode more
	regularantibleed = 30 -- affects cureable bleeds, reduce to have more blood in general
	limbantibleed = 30 -- affects bleeding of limbs, decrease to have more blood from arms and legs
	MinBloodValue = 100 -- minimum allowed blood value for human to stay alive

	LimbBleedSpeed = 0.1

	bloodgrav = -20
	blooddrag = 0
	standup = 4
	startupspeed = Vec(0,standup,0)
	upspeed = Vec(0,standup,0)
	downspeed = Vec(0,-standup,0)
	alive = true
	enabled = true
	weightb = -0.1
	startweightb = weightb
	switched = true
	attacktim = 0
	attackslash = 1
	attackforce = weightb * 100
	att1 = false
	att2 = false
	walk = true
	walktimer = 0
	s = 1
	distToCheckpoint = 0
	weight = 11
	Shock = 235
	range = 10
	PrioritizeCiv = false
	infection = 0
	InfectRange = 2
	startblood = 1000000
	xray = false
	damage = 0.1
	melle = 2
	punchsnd = LoadSound("MOD/scripts/gorescript/snd/zombie/punch.ogg")
	miss = LoadSound("MOD/scripts/gorescript/snd/zombie/miss.ogg")
	shoot = LoadSound("MOD/ak1.ogg")
	Pass = LoadSound("MOD/snd/Hit.ogg")
	tripped = false
	trippingspeed = 10
	triptimer = 0
	MaxTimeSpentAsleep = 3
	NoPoint = false
	neck = FindJoint("neck")
	enemy = Transform(Vec(0,0,0), QuatEuler(0,0,0))
	guntim = 0
	gunmaxtim = 0.2
	thinktim = 0
	maxthinktim = 15
	i = 1
	bo = 1
	--disttopath = 0
	JumpCharge = 0
	jumpdelay = 4
	agrotimer = 0
	forgortim = 15
	agroed = false
	lastPath = {}
	returnedtopath = true
	EYES = FindShape("EYES")
	oldbulletsshot = 0
	bulletsshot = 0
	bulletdamage = 0
	DeadFollowers = 0
	OldDeadFollowers = 0

	magsize = 30
	reacted = 0
	reaction = forgortim/4

	shotDelay = 0.09
	burstDelay = 1
	burstTimer = 0
	burstshots = 0
	shootTimer = 0

	bulletsshots = 0

	reloadtim = 0
	reloadmaxtim = 7
	agroed = true
end

function predeterminedpath()
		chckpnts = FindLocations("patrol")
		TorsoPos = GetBodyTransform(Torso)
	if #chckpnts < 1 then
		NoPoint = true
	else
		NoPoint = false
	end
	if s > #chckpnts then
		s = 1
	end
	if alive and not NoPoint then
		walkie()
		for i=1,#chckpnts do
        		checkpoint = chckpnts[s]
        		checkpointposition = GetLocationTransform(checkpoint)
        		distToCheckpoint = VecLength(VecSub(TorsoPos.pos, checkpointposition.pos))
        		enemy = checkpointposition
        		if distToCheckpoint < 4 then
        			returnedtopath = true
        		end
        	if distToCheckpoint < 1 then
            	s = s + 1
        	end
    	end
	end
end

function reject()
    QueryRejectBody(LLARM)
    QueryRejectBody(RRARM)
    QueryRejectBody(Torso)
    QueryRejectBody(Head)
    QueryRejectBody(LLLEG)
    QueryRejectBody(RRLEG)
    QueryRejectBody(FakeCharPos)
    QueryRejectBody(chckpntbody)
end

function GunAim()

   barrel = FindShape("barrel")

   local ct = GetShapeWorldTransform(barrel)
   local a, b, c = GetQuatEuler(ct.rot)
   local ct = Transform(ct.pos, QuatEuler(a, b, c))
   local forwardPos = TransformToParentPoint(ct, Vec(0, 0, -150))
   local direction = VecSub(forwardPos, ct.pos)
   local distance = VecLength(direction)
   local direction = VecNormalize(direction)

   QueryRejectShape(barrel)
   reject()
   local hit, hitDistance = QueryRaycast(ct.pos, direction, distance)
   if hit then
      forwardPos = TransformToParentPoint(ct, Vec(0, 0, -hitDistance))
      distance = hitDistance
   end

   return forwardPos, hit, distance

end

function deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else
        copy = orig
    end
    return copy
end

function GetAimPos()
	local ct = GetCameraTransform()
	local forwardPos = TransformToParentPoint(ct, Vec(0, 0, -100))
    local direction = VecSub(forwardPos, ct.pos)
    local distance = VecLength(direction)
	local direction = VecNormalize(direction)
	local hit, hitDistance = QueryRaycast(ct.pos, direction, distance)
	if hit then
		forwardPos = TransformToParentPoint(ct, Vec(0, 0, -hitDistance))
		distance = hitDistance
	end
	return forwardPos, hit, distance
end

function Shoot()
	aimpos, hit, distance = GetAimPos()

	burstshots = burstshots - 1

	barrel = FindShape("barrel")
	local gt = GetShapeWorldTransform(barrel)
	local fwdpos = TransformToParentPoint(gt, Vec(0, -0.1, -100))
    local gunpos = TransformToParentPoint(gt, Vec(0, -0.1, -1.6))
	dir = VecSub(fwdpos, gunpos)
	PlaySound(shoot, gunpos, 1)

	local maxSpread = InputDown("ctrl") and 1.5 or 3
	if ironsight then maxSpread = maxSpread / 3 end
	local factor = 0.05

	dir[1] = dir[1] + (math.random()-0.5)*factor
	dir[2] = dir[2] + (math.random()-0.5)*factor
	dir[3] = dir[3] + (math.random()-0.5)*factor

	ak47projectileHandler.shells[ak47projectileHandler.shellNum] = deepcopy(ak47projectileHandler.defaultShell)
	loadedShell = ak47projectileHandler.shells[ak47projectileHandler.shellNum] 
	loadedShell.active = true
	loadedShell.pos = gunpos
	loadedShell.momentum = maxMomentum
	loadedShell.predictedBulletVelocity = VecScale(dir, velocity*(400/distance))
	ak47projectileHandler.shellNum = (ak47projectileHandler.shellNum%#ak47projectileHandler.shells) + 1

	shootTimer = shotDelay

	--shootTimer = shotDelay
	--recoilTimer = shotDelay
	--lightTimer = shotDelay/2


	--if spentcasingsoption then
	--	SpentCasing()
	--end
end

function ProjectileOperations(projectile)
	projectile.predictedBulletVelocity = VecAdd(projectile.predictedBulletVelocity, (VecScale(gravity, GetTimeStep())))
	local point2 = VecAdd(projectile.pos, VecScale(projectile.predictedBulletVelocity, GetTimeStep()))
	local dir = VecNormalize(VecSub(point2, projectile.pos))
	local hit, dist, normal, shape = QueryRaycast(projectile.pos, dir, VecLength(VecSub(point2, projectile.pos)))
	

	local P = VecSub(VecAdd(GetPlayerTransform().pos, Vec(0, 1, 0)), projectile.pos)
	local T = VecSub(point2, projectile.pos)
	local N = VecScale(VecNormalize(T), VecDot(VecNormalize(T), P))
	local R = VecSub(P, N)

	if VecLength(R) < 0.5 and projectile.momentum ~= 0 then
		SetPlayerHealth(GetPlayerHealth()-0.1)
		projectile.momentum = 0
	end
--end

	if hit then
		hitPos = VecAdd(projectile.pos, VecScale(VecNormalize(VecSub(point2, projectile.pos)), dist))
		point2 = hitPos
		DrawLine(projectile.pos, point2)
		local mat, r, g, b, a = GetShapeMaterialAtPosition(shape, hitPos)

		if mat == "metal" or mat == "heavymetal" or mat == "hardmetal" then
			bounceangle = 20
		else
			bounceangle = 10
		end

		local hitangle = math.acos(VecDot(projectile.predictedBulletVelocity, normal)/VecLength(projectile.predictedBulletVelocity))*57.3-90
		if hitangle < bounceangle and math.random(0, 100)/100 > (hitangle/bounceangle)^2 then
			PlaySound(bouncesound, projectile.pos, 1, false)
			local dot = VecDot(normal, projectile.predictedBulletVelocity)
			projectile.predictedBulletVelocity = VecSub(projectile.predictedBulletVelocity, VecScale(normal, dot*(1+math.random(1,10)/10)))
		else
			ApplyBodyImpulse(GetShapeBody(shape), hitPos, VecScale(projectile.predictedBulletVelocity, velocity/200))

			if mat == "glass" and math.random() > 0.65 then
				MakeHole(hitPos, 0.75)
				projectile.momentum = projectile.momentum - 0.2
			elseif mat == "metal" or mat == "heavymetal" or mat == "hardmetal" then
				SpawnParticle("smoke", hitPos, Vec(0, 1.0+math.random(1,10)*0.1, 0), damage, 1)
				ParticleReset()
				ParticleType("plain")
				ParticleTile(6)
				ParticleSticky(0, 0)
				ParticleRadius(0.01, 0.01)
				ParticleAlpha(1, 0)
				ParticleEmissive(10, 10)
				ParticleColor(1, 0.75, 0.25, 1, 0.25, 0.25)
				ParticleGravity(-10, -10)
				for i = 1, math.random(10, 10*maxMomentum) do
					SpawnParticle(hitPos, Vec((math.random(-100,100)/100)*5,(math.random(-100,100)/100)*5, (math.random(-100,100)/100)*5), math.random(10,25)/20)
				end
				PointLight(hitPos, 1, 0.75, 0.25, 0.25)
				projectile.momentum = projectile.momentum - 1
			else
				ParticleReset()
				ParticleType("plain")
				ParticleTile(6)
				ParticleSticky(0, 0)
				ParticleRadius(0.05, 0.05)
				ParticleAlpha(a, 0)
				ParticleEmissive(0, 0)
				ParticleColor(r, g, b, r, g, b)
				ParticleGravity(-10, -10)
				for i = 1, math.random(10, 10*maxMomentum) do
					SpawnParticle(hitPos, Vec((math.random(-100,100)/100)*5,(math.random(-100,100)/100)*5, (math.random(-100,100)/100)*5), math.random(10,25)/20)
					if mat == "dirt" then
						ParticleTile(1)
						ParticleRadius(0.5, 0.1)
						SpawnParticle(hitPos, Vec((math.random(-100,100)/100),(math.random(-100,100)/100)*5, (math.random(-100,100)/100)), math.random(10,25)/20)
					end
				end
				projectile.momentum = projectile.momentum - 0.5
			end

			local factor = 1

			MakeHole(hitPos, damage*factor, damage*0.85*factor, damage*0.7*factor)
		end
	else
		point2 = VecAdd(projectile.pos, VecScale(projectile.predictedBulletVelocity, GetTimeStep()))
		DrawLine(projectile.pos, point2)
	end
	
	if projectile.momentum < 0.1 or projectile.pos[2] < 0 or VecLength(VecSub(point2, projectile.pos)) < 0.01 then
		projectile.active = false
	end

	projectile.pos = point2
end

function targetting()
	armvel = -0.9
	local bmi, bma = GetBodyBounds(RRARM)
      local bc = VecLerp(bmi, bma, 0.5)
      local ppos = VecSub(GetPlayerCameraTransform().pos, Vec(0,1,0))
      local dir = VecSub(bc, ppos)
      local dist = VecLength(dir)
      dir = VecScale(dir, 1.0 / dist)
      local add = VecScale(dir, armvel*8)
      local vel = GetBodyVelocity(RRARM)
      Vel = VecAdd(vel, add)
      SetBodyVelocity(RRARM, Vel)

      local target = enemy.pos
		local approachspeed = 35
		local smoothspeed = 35

		local ttr = GetBodyTransform(Torso)
		local currentavel = GetBodyAngularVelocity(Torso)

		local targetrot = QuatLookAt(ttr.pos, target)
		local ltargetrot = TransformToLocalTransform(ttr, Transform(Vec(), targetrot))
		local targetavel = VecScale(Vec(GetQuatEuler(ltargetrot.rot)), approachspeed)
		local diff = VecSub(targetavel, currentavel)
		diff[1] = 0 --math.max(math.min(diff[1], smoothspeed), -smoothspeed)
		diff[2] = math.max(math.min(diff[2], smoothspeed), -smoothspeed)
		diff[3] = 0 --math.max(math.min(diff[3], smoothspeed), -smoothspeed)
		SetBodyAngularVelocity(Torso, VecAdd(currentavel, diff))
		TorsoVel = VecLength(GetBodyVelocity(Torso))

		 local target = enemy.pos
		local approachspeed = 35
		local smoothspeed = 35

		local ttr = GetBodyTransform(RRARM)
		local currentavel = GetBodyAngularVelocity(RRARM)

		local targetrot = QuatLookAt(ttr.pos, target)
		local ltargetrot = TransformToLocalTransform(ttr, Transform(Vec(), targetrot))
		local targetavel = VecScale(Vec(GetQuatEuler(ltargetrot.rot)), approachspeed)
		local diff = VecSub(targetavel, currentavel)
		diff[1] = 0 --math.max(math.min(diff[1], smoothspeed), -smoothspeed)
		diff[2] = math.max(math.min(diff[2], smoothspeed), -smoothspeed)
		diff[3] = 0 --math.max(math.min(diff[3], smoothspeed), -smoothspeed)
		SetBodyAngularVelocity(RRARM, VecAdd(currentavel, diff))
		--TorsoVel = VecLength(GetBodyVelocity(Torso))
end

function walkie()
	--DebugCross(enemy.pos)
	if alive and not tripped then
		walktimer = walktimer + 0.02

		if walktimer > valkval/2 and not walked1 then
		local ppos = enemy.pos
    	local bmi, bma = GetBodyBounds(LLLEG)
		local bc = VecLerp(bmi, bma, 0.5)
		local ppos = enemy.pos
		local dir = VecSub(bc, ppos)
		local dist = VecLength(dir)
		dir = VecScale(dir, 1.0/dist)
		local add = VecScale(dir, weightb * 150)
		local vel = GetBodyVelocity(LLLEG)
		totvel = VecAdd(vel, add)
		SetBodyVelocity(LLLEG, totvel)
		walked1 = true
		walked2 = false
		end

		if walktimer > valkval and not walked2 then
		local ppos = enemy.pos
    	local bmi, bma = GetBodyBounds(RRLEG)
		local bc = VecLerp(bmi, bma, 0.5)
		local ppos = enemy.pos
		local dir = VecSub(bc, ppos)
		local dist = VecLength(dir)
		dir = VecScale(dir, 1.0/dist)
		local add = VecScale(dir, weightb * 150)
		local vel = GetBodyVelocity(RRLEG)
		totvel = VecAdd(vel, add)
		SetBodyVelocity(RRLEG, totvel)
		walked2 = true
		walked1 = false
		walktimer = 0
		end
		
		local target = enemy.pos
		local approachspeed = 35
		local smoothspeed = 35

		local ttr = GetBodyTransform(Torso)
		local currentavel = GetBodyAngularVelocity(Torso)

		local targetrot = QuatLookAt(ttr.pos, target)
		local ltargetrot = TransformToLocalTransform(ttr, Transform(Vec(), targetrot))
		local targetavel = VecScale(Vec(GetQuatEuler(ltargetrot.rot)), approachspeed)
		local diff = VecSub(targetavel, currentavel)
		diff[1] = 0 --math.max(math.min(diff[1], smoothspeed), -smoothspeed)
		diff[2] = math.max(math.min(diff[2], smoothspeed), -smoothspeed)
		diff[3] = 0 --math.max(math.min(diff[3], smoothspeed), -smoothspeed)
		SetBodyAngularVelocity(Torso, VecAdd(currentavel, diff))
		TorsoVel = VecLength(GetBodyVelocity(Torso))
		if TorsoVel < 1 then
			JumpCharge = JumpCharge + 0.1
			if JumpCharge > jumpdelay then
				add = Vec(0,40,0)
				currentheadvel = GetBodyVelocity(Head)
				SetBodyVelocity(Head, VecAdd(currentheadvel, add))
				JumpCharge = 0
			end
		end
	end
end

function retrievePath()
	lastPath = {}
	local length=GetPathLength()
	local l=0
	while l < length do
		lastPath[#lastPath+1] = GetPathPoint(l)
		l = l + 0.2
	end
end

function returntopath()
	TorsoPos = GetBodyTransform(Torso)
	local s = GetPathState()
	if restartedpath then
		predeterminedpath()
	QueryPath(enemy.pos, TorsoPos.pos)
	restartedpath = false
end

	if s == "busy" then
		thinktim = thinktim + 0.1
	end
	--if newpath then
		--alilfunk = false
		--QueryPath(enemy.pos, TorsoPos.pos)
		--newpath = false
	--end
	if thinktim > maxthinktim then
		AbortPath()
		thinktim = 0
		QueryPath(enemy.pos, TorsoPos.pos)
	end
	if s == "done" then
		retrievePath()
		walkie()
	end
	if s == "idle" or s == "fail" then
	QueryPath(enemy.pos, TorsoPos.pos)
	end


local d = 0
local l = GetPathLength()
if s == "done" then
while d < l do
	DebugCross(GetPathPoint(d))
	disttopath = VecLength(VecSub(lastPath[#lastPath - i], TorsoPos.pos))
	if disttopath > 4 then
	disttopath = 0
end
	if not alilfunk then
		disttopath = 0
		alilfunk = true
	end
	if s == "done" then
		retrievePath()
	end
	if i == 1 and s == "done" then
		enemy = Transform(lastPath[#lastPath - #lastPath + 1], QuatEuler(0,0,0))
	end
	if disttopath < 2 and #lastPath - i > 0 then
	i = i + 6
	enemy = Transform(lastPath[#lastPath - i], QuatEuler(0,0,0))
	end
	--DebugPrint(#lastPath - i)
	if #lastPath - i == 0 or #lastPath - i < 0 then
		for i = 1, #lastPath do
		 lastPath[i] = nil 
		end
		i = 1
		AbortPath()
		newpath = true
	end
	d = d + 3
	if l < 1 then
		AbortPath()
	end
end
end
		chckpnts = FindLocations("patrol")
		TorsoPos = GetBodyTransform(Torso)
	if #chckpnts < 1 then
		NoPoint = true
	else
		NoPoint = false
	end
	if alive and not NoPoint then
		--walkie()
		for i=1,#chckpnts do
        		checkpoint = chckpnts[i]
        		checkpointposition = GetLocationTransform(checkpoint)
        		distToCheckpoint = VecLength(VecSub(TorsoPos.pos, checkpointposition.pos))
        		--enemy = checkpointposition
        		if distToCheckpoint < 4 then
        			returnedtopath = true
        		end
        		--DebugPrint(distToCheckpoint)
        	--if distToCheckpoint < 1 then
            --	s = s + 1
        	--end
    	end
	end
end


function tick(dt)
DebugPrint("THIS MOD IS OUTDATED AND MAY NOT WORK PROPERLY")
    DebugPrint("DOWNLOAD GORE MOD 2 FOR A BETTER EXPERIENCE")
	agroed = true

	if bulletsshots == magsize or bulletsshots > magsize then
		reload = true
		bulletsshots = 0
		--DebugPrint("reloading")
	end

	if reload then
		reloadtim = reloadtim + dt
		if reloadtim > reloadmaxtim then
			reload = false
			reloadtim = 0
		end
	end
	--DebugPrint(bulletsshots)

	if shootTimer > 0 then
		shootTimer = shootTimer - dt
	end
	if burstshots == 0 and burstTimer <= 0 then
		burstshots = math.random(1, 5)
		burstTimer = math.random()*burstDelay+0.5
	end
	if burstTimer > 0 then
		burstTimer = burstTimer - dt
	end

	followers = FindBodies("follower", true)
	DeadFollowers = 0
	for i=1,#followers do
		follower = followers[i]
		if HasTag(follower, "dead") then
			DeadFollowers = DeadFollowers + 1
		end
	end
	if DeadFollowers > OldDeadFollowers then
		agroed = true
		OldDeadFollowers = DeadFollowers
	end

	for key, shell in ipairs(ak47projectileHandler.shells) do
		if shell.active then
			ProjectileOperations(shell)
		end
	end

	   local angRate = 0
   SetBodyAngularVelocity(Head, Vec(GetBodyAngularVelocity(Head)[1] * angRate,GetBodyAngularVelocity(Head)[2] * angRate,GetBodyAngularVelocity(Head)[3] * angRate))
   SetBodyAngularVelocity(Torso, Vec(GetBodyAngularVelocity(Torso)[1] * angRate,GetBodyAngularVelocity(Torso)[2] * angRate,GetBodyAngularVelocity(Torso)[3] * angRate))
   SetBodyAngularVelocity(LARM, Vec(GetBodyAngularVelocity(LARM)[1] * angRate,GetBodyAngularVelocity(LARM)[2] * angRate,GetBodyAngularVelocity(LARM)[3] * angRate))
   SetBodyAngularVelocity(LLARM, Vec(GetBodyAngularVelocity(LLARM)[1] * angRate,GetBodyAngularVelocity(LLARM)[2] * angRate,GetBodyAngularVelocity(LLARM)[3] * angRate))
   SetBodyAngularVelocity(RARM, Vec(GetBodyAngularVelocity(RARM)[1] * angRate,GetBodyAngularVelocity(RARM)[2] * angRate,GetBodyAngularVelocity(RARM)[3] * angRate))
   SetBodyAngularVelocity(RRARM, Vec(GetBodyAngularVelocity(RRARM)[1] * angRate,GetBodyAngularVelocity(RRARM)[2] * angRate,GetBodyAngularVelocity(RRARM)[3] * angRate))
   SetBodyAngularVelocity(LLEG, Vec(GetBodyAngularVelocity(LLEG)[1] * angRate,GetBodyAngularVelocity(LLEG)[2] * angRate,GetBodyAngularVelocity(LLEG)[3] * angRate))
   SetBodyAngularVelocity(LLLEG, Vec(GetBodyAngularVelocity(LLLEG)[1] * angRate,GetBodyAngularVelocity(LLLEG)[2] * angRate,GetBodyAngularVelocity(LLLEG)[3] * angRate))
   SetBodyAngularVelocity(RLEG, Vec(GetBodyAngularVelocity(RLEG)[1] * angRate,GetBodyAngularVelocity(RLEG)[2] * angRate,GetBodyAngularVelocity(RLEG)[3] * angRate))
   SetBodyAngularVelocity(RRLEG, Vec(GetBodyAngularVelocity(RRLEG)[1] * angRate,GetBodyAngularVelocity(RRLEG)[2] * angRate,GetBodyAngularVelocity(RRLEG)[3] * angRate))

	switched = false
		if InputPressed("H") then
		if not switched and not enabled then
			enabled = true
			switched = true
		end
		if not switched and enabled then
			enabled = false
			switched = true
		end
		end

	if IsJointBroken(neck) then
		alive = false
	end

	if not alive then
		SetTag(Head, "dead")
		SetTag(Torso, "dead")

	end
	if conditioncritical and not HasTag(Torso, "Zombie") then
		tripped = true
	end
	if conditioncritical and HasTag(Torso, "Zombie") then
		Shock = 240
	end
	if tripped and HeadVel < trippingspeed and not conditioncritical then
		triptimer = triptimer + dt
		if triptimer > MaxTimeSpentAsleep then
			tripped = false
			triptimer = 0
		end
	end
	HeadVolocity = GetBodyVelocity(Torso)
	HeadVel = VecLength(HeadVolocity)
	if HeadVel > trippingspeed then
		tripped = true
	end
	cycled = false
	if InputPressed("L") and not xray and not cycled then
		xray = true
		cycled = true
	end
	if InputPressed("L") and xray and not cycled then
		xray = false
		cycled = true
	end
	if not alive then
		RemoveTag(Torso, "Civillian")
		RemoveTag(Torso, "Zombie")
	end
	if IsBodyBroken(Torso) then
		Shock = Shock + 1
	end
	if distToCheckpoint < 4 or distToPlayer < 4 then
		close = true
	else
		close = false
	end
	if xray then
	if HasTag(Torso, "Civillian") then
		DrawBodyOutline(Head, 0,1,0,1)
	else
		DrawBodyOutline(Head, 1,1,1,1)
	end
	if not alive then
		DrawBodyOutline(Head, 1,0,0,1)
	end
end

	if IsBodyBroken(LARM) or IsBodyBroken(LLARM) then
		Leftbroke = true
	end

	if IsBodyBroken(RARM) or IsBodyBroken(RRARM) then
		rightbroke = true
	end

	if canSeePlayer() and HasTag(Torso, "Zombie") then
		agro = true
	end
	HeadPos = GetBodyTransform(Head)

	if infection > 100 then
		SetTag(Torso, "Zombie")
	end

	distToPlayer = VecLength(VecSub(HeadPos.pos, GetPlayerTransform().pos))
PrioritizeCiv = false
	if HasTag(Torso, "Zombie") then
		if distToPlayer < melle then
			Hit = true
		else
			Hit = false
		end
		infection = 100
		RemoveTag(Torso, "Civillian")
		Civillians = FindBodies("Torso", true)
		for i=1,#Civillians do
			Civillian = Civillians[i]
			if HasTag(Civillian, "Civillian") then
				CivPos = GetBodyTransform(Civillian)
				Disttociv = VecLength(VecSub(CivPos.pos, HeadPos.pos))
				--DebugLine(CivPos.pos, HeadPos.pos, 1,0,0)
				if Disttociv < range and Disttociv < distToPlayer then
					CivPos = GetBodyTransform(Civillian)
					enemy = CivPos
					PrioritizeCiv = true
					close = true
				end
			end
		end
	end


	if HasTag(Torso, "Civillian") then
		Zombies = FindBodies("Zombie", true)
		for i=1,#Zombies do
			Zombie = Zombies[i]
			ZombPos = GetBodyTransform(Zombie)
			DistToZombie = VecLength(VecSub(ZombPos.pos, HeadPos.pos))
			if DistToZombie < InfectRange then
				infection = infection + 0.1
			end
		end
	end
--reject()
if alive and not conditioncritical then
if not canSeePlayer() and not agroed then
	valkval = startvalkval
	if not returnedtopath then
	returntopath()
	else
	predeterminedpath()
end
end
if not canSeePlayer() and agroed and distToPlayer < 15 then
	valkval = startvalkval/2
	agrotimer = agrotimer + dt
	TorsoPos = GetBodyTransform(Torso)
	local s = GetPathState()
	if s == "busy" then
		thinktim = thinktim + dt
		--for i = 1, #lastPath do
		 --lastPath[i] = nil 
		--end
	end
	if newpath then
		--retrievePath()
		alilfunk = false
		QueryPath(GetPlayerTransform().pos, TorsoPos.pos)
		newpath = false
		--enemy = Transform(lastPath[#lastPath - #lastPath + 1], QuatEuler(0,0,0))
	end
	if thinktim > maxthinktim then
		AbortPath()
		thinktim = 0
		QueryPath(GetPlayerTransform().pos, TorsoPos.pos)
	end
	if s == "done" then
		retrievePath()
		walkie()
	end
	if s == "idle" or s == "fail" then
	QueryPath(GetPlayerTransform().pos, TorsoPos.pos)
end


	local d = 0
local l = GetPathLength()
if s == "done" then
while d < l do
	DebugCross(GetPathPoint(d))
	disttopath = VecLength(VecSub(lastPath[#lastPath - i], TorsoPos.pos))
	if disttopath > 4 then
	disttopath = 0
end
	if not alilfunk then
		disttopath = 0
		alilfunk = true
	end
	if s == "done" then
		retrievePath()
	end
	if i == 1 and s == "done" then
		enemy = Transform(lastPath[#lastPath - #lastPath + 1], QuatEuler(0,0,0))
	end
	if disttopath < 2 and #lastPath - i > 0 then
	i = i + 6
	enemy = Transform(lastPath[#lastPath - i], QuatEuler(0,0,0))
	end
	if #lastPath - i == 0 or #lastPath - i < 0 then
		for i = 1, #lastPath do
		 lastPath[i] = nil 
		end
		i = 1
		AbortPath()
		newpath = true
	end
	d = d + 3
	if l < 1 then
		AbortPath()
	end
end
end
end
if agrotimer > forgortim then
	agroed = false
	agrotimer = 0
	end
	if not canSeePlayer() then
	reacted = 0
	end
if canSeePlayer() then
	reacted = reacted + dt
	agroed = true
	restartedpath = true
	returnedtopath = false
	agrotimer = 0
	--retrievePath()
	for i = 1, #lastPath do
		 lastPath[i] = nil 
		end
	i = 1
	AbortPath()
	newpath = true
	enemy = GetPlayerTransform()
	targetting()

	valkval = 9999
	guntim = guntim + dt
	if shootTimer <= 0 and not conditioncritical and burstshots > 0 and reacted > reaction/4 and not reload then
		bulletsshots = bulletsshots + 1
		bulletsshot = bulletsshot + 1
		ApplyBodyImpulse(RRARM, Vec(0,0,0), Vec(math.random(-10,10), math.random(0,15), math.random(-10,10)))
		Shoot()
		guntim = 0
	end
else
	valkval = startvalkval
end
end

	if PrioritizeCiv then
		agro = true
	end
	NoPoint = true
	if alive then

	  if alive and walk then
    	if agro or HasTag(Torso, "Zombie") then
    		trippingspeed = 10
    		attacktim = attacktim + dt
    local ppos = enemy.pos
    local bmi, bma = GetBodyBounds(LLARM)
		local bc = VecLerp(bmi, bma, 0.5)
		local ppos = enemy.pos
		local dir = VecSub(bc, ppos)
		local dist = VecLength(dir)
		dir = VecScale(dir, 1.0/dist)
		weightb = startweightb

	if attacktim > attackslash then
		if not att1 then
    weightb = attackforce
	if not Leftbroke then
	local add = VecScale(dir, weightb)
	local vel = GetBodyVelocity(LLARM)
	vel = VecAdd(vel, add)
    SetBodyVelocity(LLARM, vel)
    if Hit then
    	--SetPlayerHealth(GetPlayerHealth() - damage)
    	PlaySound(punchsnd, HeadPos.pos)
    else
    	--PlaySound(miss, HeadPos.pos)
    end
    att1 = true
    att2 = false
	end
	end

	if attacktim > attackslash * 2 then
		if not att2 then
	weightb = attackforce
    attacktim = 0
    if not rightbroke then
    local add = VecScale(dir, weightb)
	local vel = GetBodyVelocity(LLARM)
	vel = VecAdd(vel, add)
    SetBodyVelocity(RRARM, vel)
    att2 = true
    att1 = false
   if Hit then
    	--SetPlayerHealth(GetPlayerHealth() - damage)
    	PlaySound(punchsnd, HeadPos.pos)
    else
    	--PlaySound(miss, HeadPos.pos)
    end

	end
    end
end
end
    weightb = startweightb
local bmi, bma = GetBodyBounds(RRARM)
		local bc = VecLerp(bmi, bma, 0.5)
		local ppos = enemy.pos
		local dir = VecSub(bc, ppos)
		local dist = VecLength(dir)
		dir = VecScale(dir, 1.0/dist)
    local add = VecScale(dir, weightb)
	local vel = GetBodyVelocity(RRARM)
	vel = VecAdd(vel, add)
	if not rightbroke then
    SetBodyVelocity(RRARM, vel)
end
if not Leftbroke then
    SetBodyVelocity(LLARM, vel)
end
end
end

	gunTrans = GetShapeWorldTransform(EYES)
	gunPos = gunTrans.pos
	direction = TransformToParentVec(gunTrans, Vec(0, -1, 0))
	 shootPos = VecAdd(gunPos, VecScale(direction,0.2))

	if IsBodyBroken(Head) then
		alive = false
	end
end

	drawtext = false

	HeadBloodCapacity = GetBodyMass(Head)
	Bleed = StartingBleed - HeadBloodCapacity
	HeadPos = GetBodyTransform(Head)

	TorsoBloodCapacity = GetBodyMass(Torso)
	Bleed1 = StartingBleed1 - TorsoBloodCapacity
	TorsoPos = GetBodyTransform(Torso)

	LARMBloodCapacity = GetBodyMass(LARM)
	Bleed2 = StartingBleed2 - LARMBloodCapacity
	LARMPos = GetBodyTransform(LARM)

	LLARMBloodCapacity = GetBodyMass(LLARM)
	Bleed3 = StartingBleed3 - LLARMBloodCapacity
	LLARMPos = GetBodyTransform(LLARM)

	RARMBloodCapacity = GetBodyMass(RARM)
	Bleed4 = StartingBleed4 - RARMBloodCapacity
	RARMPos = GetBodyTransform(RARM)

	RRARMBloodCapacity = GetBodyMass(RRARM)
	Bleed5 = StartingBleed5 - RRARMBloodCapacity
	RRARMPos = GetBodyTransform(RRARM)

	LLEGBloodCapacity = GetBodyMass(LLEG)
	Bleed6 = StartingBleed6 - LLEGBloodCapacity
	LLEGPos = GetBodyTransform(LLEG)

	LLLEGBloodCapacity = GetBodyMass(LLLEG)
	Bleed7 = StartingBleed7 - LLLEGBloodCapacity
	LLLEGPos = GetBodyTransform(LLLEG)

	RLEGBloodCapacity = GetBodyMass(RLEG)
	Bleed8 = StartingBleed8 - RLEGBloodCapacity
	RLEGPos = GetBodyTransform(RLEG)

	RRLEGBloodCapacity = GetBodyMass(RRLEG)
	Bleed9 = StartingBleed9 - RRLEGBloodCapacity
	RRLEGPos = GetBodyTransform(RRLEG)

--HEAD HEAD HEAD HEAD HEAD HEAD LLEGHEAD HEAD HEAD HEAD
	if bleed then
	if IsBodyBroken(Head) then

		for i=1, 9 do
		 	 thingz = FindJoints("eye")
		 	 for i=1, #thingz do
		 	 	thinz = thingz[i]
		 	 	Delete(thinz)
		 	 end
		 end

		for i=1,Bleed/2 do
		smoke()
	end
end
end

if bleed then
	
		if HeadBloodCapacity < MaxBloodCapacity then
		Bleed = Bleed * 6 

		for i=1,Bleed/6 do
		smoke()
	end
	end

HeadBloodLevel = HeadBloodLevel - Bleed/2
end

	if HeadBloodLevel <= 0 then
		bleed = false
		HeadBloodLevel = 0
	end

	--TORSO TORSO TORSO TORSO TORSO TORSO TORSO

	if bleed1 then
	if IsBodyBroken(Torso) then
		for i=1,Bleed1/regularantibleed do
		smoke1()
	end
end
end

if bleed1 then

		if TorsoBloodCapacity < MaxBloodCapacity1/2 then
		Bleed1 = Bleed1 * 6 

		 for i=1, 9 do
		 	 things = FindBodies("gut", true)
		 	 for i=1, #things do
		 	 	thing = things[i]
		 	 	SetBodyDynamic(thing, true)
		 	 end
		 end
		for i=1,Bleed1/extremeantibleed do
		smoke1()
	end
	end

TorsoBloodLevel = TorsoBloodLevel - Bleed1
end

	if TorsoBloodLevel <= 0 then
		bleed1 = false
		TorsoBloodLevel = 0
	end

-- ARMARMARMARMAMRAMRMARMAMRAMRMARMAMRAMMARMAMAMRMARMMRMARMRMAMRMAR

if bleed2 then

	if LARMBloodCapacity < MaxBloodCapacity2/3 then
		Bleed2 = Bleed2 * 6 

		for i=1,Bleed2/extremeantibleed do
		smoke2()
	end
	end

	if IsBodyBroken(LARM) then
		for i=1,Bleed2/limbantibleed do
		smoke2()
	end
end
end

if bleed2 then
LARMBloodLevel = LARMBloodLevel - Bleed2*LimbBleedSpeed
end

	if LARMBloodLevel <= 0 then
		bleed2 = false
		LARMBloodLevel = 0
	end

	--aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa

if bleed3 then

	if LLARMBloodCapacity < MaxBloodCapacity3/3 then
		Bleed3 = Bleed3 * 6 

		for i=1,Bleed3/extremeantibleed do
		smoke3()
	end
	end

	if IsBodyBroken(LLARM) then
		for i=1,Bleed3/limbantibleed do
		smoke3()
	end
end
end

if bleed3 then
LLARMBloodLevel = LLARMBloodLevel - Bleed3*LimbBleedSpeed
end

	if LLARMBloodLevel <= 0 then
		bleed3 = false
		LLARMBloodLevel = 0
	end

	--aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa

	if bleed4 then

		if RARMBloodCapacity < MaxBloodCapacity4/3 then
		Bleed4 = Bleed4 * 6 

		for i=1,Bleed4/extremeantibleed do
		smoke4()
	end
	end

	if IsBodyBroken(RARM) then
		for i=1,Bleed4/limbantibleed do
		smoke4()
	end
end
end

if bleed4 then
RARMBloodLevel = RARMBloodLevel - Bleed4*LimbBleedSpeed
end

	if RARMBloodLevel <= 0 then
		bleed4 = false
		RARMBloodLevel = 0
	end

	--aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa

	if bleed5 then

		if RRARMBloodCapacity < MaxBloodCapacity5/3 then
		Bleed5 = Bleed5 * 6 

		for i=1,Bleed5/extremeantibleed do
		smoke5()
	end
	end

	if IsBodyBroken(RRARM) then
		for i=1,Bleed5/limbantibleed do
		smoke5()
	end
end
end

if bleed5 then
RRARMBloodLevel = RRARMBloodLevel - Bleed5*LimbBleedSpeed
end

	if RRARMBloodLevel <= 0 then
		bleed5 = false
		RRARMBloodLevel = 0
	end

	--LEGLEGLEGLELGLELGLGLELGLEGLLGLEGLELGLEGLELGLEGLEGLELGELLEGLEGLLEGLEGLGELGELGLEGLELGELGLEGLEGLLEGLEGLLEGLELGLEGLELGLEGLLEGLELGELGELG

	if bleed6 then

		if LLEGBloodCapacity < MaxBloodCapacity6/3 then
		Bleed6 = Bleed6 * 6 

		for i=1,Bleed6/extremeantibleed do
		smoke6()
	end
	end

	if IsBodyBroken(LLEG) then
		for i=1,Bleed6/limbantibleed do
		smoke6()
	end
end
end

if bleed6 then
LLEGBloodLevel = LLEGBloodLevel - Bleed6*LimbBleedSpeed
end

	if LLEGBloodLevel <= 0 then
		bleed6 = false
	LLEGBloodLevel = 0
	end

	--lllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllll

	if bleed7 then

		if LLLEGBloodCapacity < MaxBloodCapacity7/3 then
		Bleed7 = Bleed7 * 6 

		for i=1,Bleed7/extremeantibleed do
		smoke7()
	end
	end

	if IsBodyBroken(LLLEG) then
		for i=1,Bleed7/limbantibleed do
		smoke7()
	end
end
end

if bleed7 then
LLLEGBloodLevel = LLLEGBloodLevel - Bleed7*LimbBleedSpeed
end

	if LLLEGBloodLevel <= 0 then
		bleed7 = false
	LLLEGBloodLevel = 0
	end

	--lllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllll

	if bleed8 then

		if RLEGBloodCapacity < MaxBloodCapacity8/3 then
		Bleed8 = Bleed8 * 6 

		for i=1,Bleed8/extremeantibleed do
		smoke8()
	end
	end

	if IsBodyBroken(RLEG) then
		for i=1,Bleed8/limbantibleed do
		smoke8()
	end
end
end

if bleed8 then
RLEGBloodLevel = RLEGBloodLevel - Bleed8*LimbBleedSpeed
end

	if RLEGBloodLevel <= 0 then
		bleed8 = false
	RLEGBloodLevel = 0
	end

	--lllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllll

	if bleed9 then

		if RRLEGBloodCapacity < MaxBloodCapacity9/3 then
		Bleed9 = Bleed9 * 6 

		for i=1,Bleed9/extremeantibleed do
		smoke9()
	end
	end

	if IsBodyBroken(RRLEG) then
		for i=1,Bleed9/limbantibleed do
		smoke9()
	end
end
end

if bleed9 then
RRLEGBloodLevel = RRLEGBloodLevel - Bleed9*LimbBleedSpeed
end

	if RRLEGBloodLevel <= 0 then
		bleed9 = false
	RRLEGBloodLevel = 0
	end

	TotalLegBloodCapacity = MaxBloodCapacity6 + MaxBloodCapacity7 + MaxBloodCapacity8 + MaxBloodCapacity9
	TotalLegBloodValue = RRLEGBloodLevel + RLEGBloodLevel + LLLEGBloodLevel + LLEGBloodLevel

	TotalBloodValue = RRLEGBloodLevel + RLEGBloodLevel + LLLEGBloodLevel + LLEGBloodLevel + RRARMBloodLevel + RARMBloodLevel + LLARMBloodLevel + LARMBloodLevel + TorsoBloodLevel + HeadBloodLevel
		upspeed[2] = TotalLegBloodValue/Shock
		if IsBodyBroken(LLLEG) then
			upspeed[2] = upspeed[2] / 2
		end
		if IsBodyBroken(LRLEG) then
			upspeed[2] = upspeed[2] / 2
		end



	currentvel = GetBodyVelocity(Head)
	currentvel1 = GetBodyVelocity(LLLEG)
	currentvel2 = GetBodyVelocity(RRLEG)

	if IsBodyBroken(Head) then
		alive = false
	end

	if not HasTag(Torso, "Zombie") then
	if TorsoBloodLevel < MaxBloodCapacity1/4 or TorsoBloodCapacity < MaxBloodCapacity1/3 then
		alive = false
	end

	if TotalBloodValue < MinBloodValue then
		alive = false
	end
end
	if alive and not tripped then
	SetBodyVelocity(Head,VecAdd(currentvel,upspeed))
	SetBodyVelocity(LLLEG,VecAdd(currentvel1,downspeed))
	SetBodyVelocity(RRLEG,VecAdd(currentvel2,downspeed))
end

a = GetPlayerTransform()

	distToPlayer = VecLength(VecSub(a.pos, TorsoPos.pos))
	if distToPlayer < 3 then
		inrange = true
	else
		inrange = false
	end

	if not started then
		startblood = TotalBloodValue
		started = true
	end

	if TotalBloodValue < startblood/1.1 then
		conditioncritical = true
	end

end


function smoke()
    --spawn sparks
    ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(HeadPos.pos, Vec(math.random(-Bleed/antibleed, Bleed/antibleed), math.random(-Bleed/antibleed, Bleed/antibleed), math.random(-Bleed/antibleed, Bleed/antibleed)),10)
end

function smoke1()
    --spawn sparks
     ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(TorsoPos.pos, Vec(math.random(-Bleed1/antibleed, Bleed1/antibleed), math.random(-Bleed1/antibleed, Bleed1/antibleed), math.random(-Bleed1/antibleed, Bleed1/antibleed)),10)
end

function smoke2()
    --spawn sparks
    ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(LARMPos.pos, Vec(math.random(-Bleed2/antibleed, Bleed2/antibleed), math.random(-Bleed2/antibleed, Bleed2/antibleed), math.random(-Bleed2/antibleed, Bleed2/antibleed)),10)
end

function smoke3()
    --spawn sparks
     ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(LLARMPos.pos, Vec(math.random(-Bleed3/antibleed, Bleed3/antibleed), math.random(-Bleed3/antibleed, Bleed3/antibleed), math.random(-Bleed3/antibleed, Bleed3/antibleed)),10)
end

function smoke4()
    --spawn sparks
    ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(RARMPos.pos, Vec(math.random(-Bleed3/antibleed, Bleed3/antibleed), math.random(-Bleed3/antibleed, Bleed3/antibleed), math.random(-Bleed3/antibleed, Bleed3/antibleed)),10)
end

function smoke5()
    --spawn sparks
    ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(RRARMPos.pos, Vec(math.random(-Bleed3/antibleed, Bleed3/antibleed), math.random(-Bleed3/antibleed, Bleed3/antibleed), math.random(-Bleed3/antibleed, Bleed3/antibleed)),10)
end

function smoke6()
    --spawn sparks
    ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(LLEGPos.pos, Vec(math.random(-Bleed3/antibleed, Bleed3/antibleed), math.random(-Bleed3/antibleed, Bleed3/antibleed), math.random(-Bleed3/antibleed, Bleed3/antibleed)),10)
end

function smoke7()
    --spawn sparks
    ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(LLLEGPos.pos, Vec(math.random(-Bleed3/antibleed, Bleed3/antibleed), math.random(-Bleed3/antibleed, Bleed3/antibleed), math.random(-Bleed3/antibleed, Bleed3/antibleed)),10)
end

function smoke8()
    --spawn sparks
    ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(RLEGPos.pos, Vec(math.random(-Bleed3/antibleed, Bleed3/antibleed), math.random(-Bleed3/antibleed, Bleed3/antibleed), math.random(-Bleed3/antibleed, Bleed3/antibleed)),10)
end

function smoke9()
    --spawn sparks
    ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(bloodgrav)
    ParticleSticky(0.5)
    ParticleDrag(blooddrag)
    ParticleStretch(1)
    SpawnParticle(RRLEGPos.pos, Vec(math.random(-Bleed3/antibleed, Bleed3/antibleed), math.random(-Bleed3/antibleed, Bleed3/antibleed), math.random(-Bleed3/antibleed, Bleed3/antibleed)),10)
end

function canSeePlayer()
    local camTrans = GetPlayerCameraTransform()
	local playerPos = camTrans.pos

	--Direction to player
	local dir = VecSub(playerPos, shootPos)
	local dist = VecLength(dir)
	dir = VecNormalize(dir)

	QueryRejectVehicle(GetPlayerVehicle())
	reject()
	return not QueryRaycast(shootPos, dir, dist, 0, true)
end

function projectile()
	    ParticleType("smoke")
    ParticleColor(0.3, 0, 0)
    ParticleRadius(0.05, 0.005)
    ParticleAlpha(1000)
    ParticleCollide(1)
    ParticleGravity(5)
    ParticleSticky(0.5)
    ParticleDrag(0)
    ParticleStretch(1)
    SpawnParticle(GunAim(), Vec(0,0,0),10)
	end